;==============================================================================

; file: "_error#.scm"

; Copyright (C) 1994-2001 by Marc Feeley, All Rights Reserved.

;==============================================================================

; Exception handling.

(define-check-type-macro type-exception macro-type-exception?)

(##define-macro (macro-make-type-exception procedure arguments arg-num type-id)
  `(let ((procedure ,procedure)
         (arguments ,arguments) 
         (arg-num ,arg-num)
         (type-id ,type-id))
     (macro-make-structure-object
      ##type-exception-tag
      procedure
      arguments
      arg-num
      type-id)))

(##define-macro (macro-type-exception? obj)
  `(macro-structure-object? ,obj ##type-exception-tag))

(##define-macro (macro-type-exception-procedure exc)
  `(macro-slot 1 ,exc))
(##define-macro (macro-type-exception-procedure-set! exc obj)
  `(macro-slot 1 ,exc ,obj))
(##define-macro (macro-type-exception-arguments exc)
  `(macro-slot 2 ,exc))
(##define-macro (macro-type-exception-arguments-set! exc obj)
  `(macro-slot 2 ,exc ,obj))
(##define-macro (macro-type-exception-arg-num exc)
  `(macro-slot 3 ,exc))
(##define-macro (macro-type-exception-arg-num-set! exc obj)
  `(macro-slot 3 ,exc ,obj))
(##define-macro (macro-type-exception-type-id exc)
  `(macro-slot 4 ,exc))
(##define-macro (macro-type-exception-type-id-set! exc obj)
  `(macro-slot 4 ,exc ,obj))

(define-check-type-macro os-exception macro-os-exception?)

(##define-macro (macro-make-os-exception procedure arguments code)
  `(let ((procedure ,procedure)
         (arguments ,arguments)
         (code ,code))
     (macro-make-structure-object
      ##os-exception-tag
      procedure
      arguments
      code)))

(##define-macro (macro-os-exception? obj)
  `(macro-structure-object? ,obj ##os-exception-tag))

(##define-macro (macro-os-exception-procedure exc)
  `(macro-slot 1 ,exc))
(##define-macro (macro-os-exception-procedure-set! exc obj)
  `(macro-slot 1 ,exc ,obj))
(##define-macro (macro-os-exception-arguments exc)
  `(macro-slot 2 ,exc))
(##define-macro (macro-os-exception-arguments-set! exc obj)
  `(macro-slot 2 ,exc ,obj))
(##define-macro (macro-os-exception-code exc)
  `(macro-slot 3 ,exc))
(##define-macro (macro-os-exception-code-set! exc obj)
  `(macro-slot 3 ,exc ,obj))

;==============================================================================
