;==============================================================================

; file: "_eval#.scm"

; Copyright (C) 1994-2001 by Marc Feeley, All Rights Reserved.

;==============================================================================

; Representation of exceptions.

(define-check-type-macro
  expression-parsing-exception
  macro-expression-parsing-exception?)

(##define-macro (macro-make-expression-parsing-exception kind source parameters)
  `(let ((kind ,kind) (source ,source) (parameters ,parameters))
     (macro-make-structure-object
      ##expression-parsing-exception-tag
      kind
      source
      parameters)))

(##define-macro (macro-expression-parsing-exception? obj)
  `(macro-structure-object? ,obj ##expression-parsing-exception-tag))

(##define-macro (macro-expression-parsing-exception-kind exc)
  `(macro-slot 1 ,exc))
(##define-macro (macro-expression-parsing-exception-kind-set! exc obj)
  `(macro-slot 1 ,exc ,obj))
(##define-macro (macro-expression-parsing-exception-source exc)
  `(macro-slot 2 ,exc))
(##define-macro (macro-expression-parsing-exception-source-set! exc obj)
  `(macro-slot 2 ,exc ,obj))
(##define-macro (macro-expression-parsing-exception-parameters exc)
  `(macro-slot 3 ,exc))
(##define-macro (macro-expression-parsing-exception-parameters-set! exc obj)
  `(macro-slot 3 ,exc ,obj))

(define-check-type-macro
  unbound-global-exception
  macro-unbound-global-exception?)

(##define-macro (macro-make-unbound-global-exception code rte variable)
  `(let ((code ,code) (rte ,rte) (variable ,variable))
     (macro-make-structure-object
      ##unbound-global-exception-tag
      code
      rte
      variable)))

(##define-macro (macro-unbound-global-exception? obj)
  `(macro-structure-object? ,obj ##unbound-global-exception-tag))

(##define-macro (macro-unbound-global-exception-code exc)
  `(macro-slot 1 ,exc))
(##define-macro (macro-unbound-global-exception-code-set! exc obj)
  `(macro-slot 1 ,exc ,obj))
(##define-macro (macro-unbound-global-exception-rte exc)
  `(macro-slot 2 ,exc))
(##define-macro (macro-unbound-global-exception-rte-set! exc obj)
  `(macro-slot 2 ,exc ,obj))
(##define-macro (macro-unbound-global-exception-variable exc)
  `(macro-slot 3 ,exc))
(##define-macro (macro-unbound-global-exception-variable-set! exc obj)
  `(macro-slot 3 ,exc ,obj))

(define-check-type-macro
  nonprocedure-send-exception
  macro-nonprocedure-send-exception?)

(##define-macro (macro-make-nonprocedure-send-exception code rte)
  `(let ((code ,code) (rte ,rte))
     (macro-make-structure-object
      ##nonprocedure-send-exception-tag
      code
      rte)))

(##define-macro (macro-nonprocedure-send-exception? obj)
  `(macro-structure-object? ,obj ##nonprocedure-send-exception-tag))

(##define-macro (macro-nonprocedure-send-exception-code exc)
  `(macro-slot 1 ,exc))
(##define-macro (macro-nonprocedure-send-exception-code-set! exc obj)
  `(macro-slot 1 ,exc ,obj))
(##define-macro (macro-nonprocedure-send-exception-rte exc)
  `(macro-slot 2 ,exc))
(##define-macro (macro-nonprocedure-send-exception-rte-set! exc obj)
  `(macro-slot 2 ,exc ,obj))

(define-check-type-macro
  zzznonprocedure-operator-exception
  macro-zzznonprocedure-operator-exception?)

(##define-macro (macro-make-zzznonprocedure-operator-exception code rte)
  `(let ((code ,code) (rte ,rte))
     (macro-make-structure-object
      ##zzznonprocedure-operator-exception-tag
      code
      rte)))

(##define-macro (macro-zzznonprocedure-operator-exception? obj)
  `(macro-structure-object? ,obj ##zzznonprocedure-operator-exception-tag))

(##define-macro (macro-zzznonprocedure-operator-exception-code exc)
  `(macro-slot 1 ,exc))
(##define-macro (macro-zzznonprocedure-operator-exception-code-set! exc obj)
  `(macro-slot 1 ,exc ,obj))
(##define-macro (macro-zzznonprocedure-operator-exception-rte exc)
  `(macro-slot 2 ,exc))
(##define-macro (macro-zzznonprocedure-operator-exception-rte-set! exc obj)
  `(macro-slot 2 ,exc ,obj))

(define-check-type-macro
  global-environment-overflow-exception
  macro-global-environment-overflow-exception?)

(##define-macro (macro-make-global-environment-overflow-exception variable)
  `(let ((variable ,variable))
     (macro-make-structure-object
      ##global-environment-overflow-exception-tag
      variable)))

(##define-macro (macro-global-environment-overflow-exception? obj)
  `(macro-structure-object? ,obj ##global-environment-overflow-exception-tag))

(##define-macro (macro-global-environment-overflow-exception-variable exc)
  `(macro-slot 1 ,exc))
(##define-macro (macro-global-environment-overflow-exception-variable-set! exc obj)
  `(macro-slot 1 ,exc ,obj))

;------------------------------------------------------------------------------

;;;;;;;;;;;;;;;;;;;;;;;
; Error handling.

(##define-macro (macro-trap-load form msg)
  (define (flat x) (if (pair? x) (cons (car x) (flat (cdr x))) (list x)))
  (if (list? form)
    `(##trap-load ,msg ',(car form) ,@(cdr form))
    `(##trap-load* ,msg ',(car form) ,@(flat (cdr form)))))

;==============================================================================
