;==============================================================================

; file: "_std#.scm"

; Copyright (C) 1994-2001 by Marc Feeley, All Rights Reserved.

;==============================================================================

; Runtime exception handling.

(define-check-type-macro string         ##string?)
(define-check-type-macro string-list    ##string?)
(define-check-type-macro vector         ##vector?)
(define-check-type-macro vector-list    ##vector?)
(define-check-type-macro s8vector       ##s8vector?)
(define-check-type-macro s8vector-list  ##s8vector?)
(define-check-type-macro u8vector       ##u8vector?)
(define-check-type-macro u8vector-list  ##u8vector?)
(define-check-type-macro s16vector      ##s16vector?)
(define-check-type-macro s16vector-list ##s16vector?)
(define-check-type-macro u16vector      ##u16vector?)
(define-check-type-macro u16vector-list ##u16vector?)
(define-check-type-macro s32vector      ##s32vector?)
(define-check-type-macro s32vector-list ##s32vector?)
(define-check-type-macro u32vector      ##u32vector?)
(define-check-type-macro u32vector-list ##u32vector?)
(define-check-type-macro s64vector      ##s64vector?)
(define-check-type-macro s64vector-list ##s64vector?)
(define-check-type-macro u64vector      ##u64vector?)
(define-check-type-macro u64vector-list ##u64vector?)
(define-check-type-macro f32vector      ##f32vector?)
(define-check-type-macro f32vector-list ##f32vector?)
(define-check-type-macro f64vector      ##f64vector?)
(define-check-type-macro f64vector-list ##f64vector?)
(define-check-type-macro pair           ##pair?)
(define-check-type-macro pair-list      ##pair?)
(define-check-type-macro list           ##null?)
(define-check-type-macro symbol         ##symbol?)
(define-check-type-macro char           ##char?)
(define-check-type-macro char-list      ##char?)
(define-check-type-macro procedure      ##procedure?)
(define-check-type-macro keyword        ##keyword?)

;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
(##define-macro (macro-fail-check-list arg-num form)
  (define (flat x) (if (pair? x) (cons (car x) (flat (cdr x))) (list x)))
  (if (list? form)
    `(##fail-check-list ,arg-num ,(car form) ,@(cdr form))
    `(##fail-check-list ,arg-num #t ,(car form) ,@(flat (cdr form)))))

;------------------------------------------------------------------------------

; Representation of exceptions.

(define-check-type-macro
  improper-length-list-exception
  macro-improper-length-list-exception?)

(##define-macro (macro-make-improper-length-list-exception procedure arguments arg-num)
  `(let ((procedure ,procedure)
         (arguments ,arguments)
         (arg-num ,arg-num))
     (macro-make-structure-object
      ##improper-length-list-exception-tag
      procedure
      arguments
      arg-num)))

(##define-macro (macro-improper-length-list-exception? obj)
  `(macro-structure-object? ,obj ##improper-length-list-exception-tag))

(##define-macro (macro-improper-length-list-exception-procedure exc)
  `(macro-slot 1 ,exc))
(##define-macro (macro-improper-length-list-exception-procedure-set! exc obj)
  `(macro-slot 1 ,exc ,obj))
(##define-macro (macro-improper-length-list-exception-arguments exc)
  `(macro-slot 2 ,exc))
(##define-macro (macro-improper-length-list-exception-arguments-set! exc obj)
  `(macro-slot 2 ,exc ,obj))
(##define-macro (macro-improper-length-list-exception-arg-num exc)
  `(macro-slot 3 ,exc))
(##define-macro (macro-improper-length-list-exception-arg-num-set! exc obj)
  `(macro-slot 3 ,exc ,obj))

;==============================================================================
